# ej2-vue-gantt

The Gantt component is designed to visualize and edit the project schedule, and track the project progress. It helps to organize and schedule the projects and also you can update the project schedule through interactions like editing, dragging and resizing.

> This is a commercial product and requires a paid license for possession or use. Syncfusion’s licensed software, including this component, is subject to the terms and conditions of Syncfusion's EULA (https://www.syncfusion.com/eula/es/). To acquire a license, you can purchase one at https://www.syncfusion.com/sales/products or start a free 30-day trial here (https://www.syncfusion.com/account/manage-trials/start-trials).

> A free community license (https://www.syncfusion.com/products/communitylicense) is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue and five or fewer developers.

## Setup

To install Gantt and its dependent packages, use the following command.

```sh
npm install @syncfusion/ej2-vue-gantt
```

## Resources

* [Getting Started](https://ej2.syncfusion.com/vue/documentation/gantt/getting-started/)
* [View Online Demos](https://ej2.syncfusion.com/vue/demos/?utm_source=npm&utm_campaign=gantt#/material/gantt/default.html)

## Supported Frameworks

Gantt component is also offered in following list of frameworks.

1. [Angular](https://github.com/syncfusion/ej2-angular-ui-components/tree/master/components/gantt)
2. [React](https://github.com/syncfusion/ej2-react-ui-components/tree/master/components/gantt)
3. [ASP.NET Core](https://www.syncfusion.com/aspnet-core-ui-controls/gantt)
4. [ASP.NET MVC](https://www.syncfusion.com/aspnet-mvc-ui-controls/gantt)
5. [JavaScript (ES5)](https://www.syncfusion.com/javascript-ui-controls/gantt)

## Key Features

* **Data sources** - Bind hierarchical or self-referential data to Gantt chart with an array of JavaScript objects or DataManager.
* **Timeline** – Display timescale from minutes to decades easily, and also display custom texts in the timeline units. Timeline can be displayed in either one-tier or two-tier layout.
* **Customizable Taskbars** – Display various tasks in a project using child taskbar, summary taskbar and milestone UI, that can also be customized with templates.
* **Unscheduled tasks** – Support for displaying tasks with undefined start date, end date or duration in a project.
* **Baselines** – Display the deviations between planned dates and actual dates of a task in a project using baselines.
* **CRUD actions** – Provides the options to dynamically insert, delete and update tasks using columns, dialog and taskbar editing options.
* **Task dependency** – Define or update the dependencies between the tasks in a project with four types of task dependencies Finish – Start, Start – Finish, Finish – Finish, Start – Start.
* **Markers and indicators** - Support for displaying indicators and flags along with taskbars and task labels. Also map important events in a project using event marker.
* **Task label customization**- provides option to set desired label inside task bar and right and left side of task bar.
* **Resources**- Allows you to assign and track performance of resource to particular task.
* **Sorting** - Supports n levels of sorting.
* **Filtering** - Offers filter UI such as filter bar, menu, excel and checkbox at each column to filter data.
* **Editing** - provides the options for create, read, update, and delete operations.
* **Columns** - The column definitions are used as the dataSource schema in the gantt. This plays a vital role in rendering column values in the required format.
  * **Reordering** - Allows you to drag any column and drop it at any position in the gantt column header row, allowing columns to be repositioned.
  * **Column Chooser**- The column chooser provides a list of column names paired with check boxes that allow the visibility to be toggled on the fly.
  * **Resizing**- Resizing allows changing column width on the fly by simply dragging the right corner of the column header.
* **Selection**- Rows or cells can be selected in the gantt. One or more rows or cells can also be selected by holding Ctrl or Command, or programmatically.
* **Templates** - Templates can be used to create custom user experiences in the gantt.
* **Enriched UI** – Support for Material, bootstrap, fabric and high contrast themes along with other UI options like holidays support, vertical and horizontal grid lines support and so on.
* **Localization** - Provides inherent support to localize the UI.

## Support

Product support is available for through following mediums.

* Creating incident in Syncfusion [Direct-trac](https://www.syncfusion.com/support/directtrac/incidents?utm_source=npm&utm_campaign=gantt) support system or [Community forum](https://www.syncfusion.com/forums?utm_source=npm&utm_campaign=gantt).
* New [GitHub issue](https://github.com/syncfusion/ej2-vue-ui-components/issues/new).
* Ask your query in Stack Overflow with tag `syncfusion`, `ej2`.

## License

Check the license detail [here](https://github.com/syncfusion/ej2-vue-ui-components/blob/master/license).

## Changelog

Check the changelog [here](https://github.com/syncfusion/ej2-vue-ui-components/blob/master/components/gantt/CHANGELOG.md)

&copy; Copyright 2019 Syncfusion, Inc. All Rights Reserved. The Syncfusion Essential Studio license and copyright applies to this distribution.
